import java.net.*; // SocketServerSocketɬ
import java.io.*; // IOExceptionɬ

class PoolDispatcher implements Dispatcher {

  static final String NUMTHREADS = "8"; // åɥסΥǥեȥ
  static final String THREADPROP = "Threads"; // åɥץѥƥ̾

  private int numThreads; // ס˴ޤޤ륹åɤο

  public PoolDispatcher() {
    // Systemץѥƥ饹åɤο뤫ǥեͤѤ
    numThreads = Integer.parseInt(System.getProperty(THREADPROP, NUMTHREADS));
  }

  public void startDispatching(final ServerSocket servSock, final Logger logger,
                               final ProtocolFactory protoFactory) {
    // 줾줬ȿФȤư롢N-1ĤΥåɤ
    for (int i = 0; i < (numThreads - 1); i++) {
      Thread thread = new Thread() {
        public void run() {
          dispatchLoop(servSock, logger, protoFactory);
        }
      };
      thread. start();
      logger.writeEntry("Created and started Thread = " + thread.getName());
    }
    logger.writeEntry("Iterative server starting in main thread " +
                    Thread.currentThread().getName());
    // ᥤ󥹥åɤNܤȿФȤƻѤ
    dispatchLoop(servSock, logger, protoFactory);
    /* NOT REACHED */
  }

  private void dispatchLoop(ServerSocket servSock, Logger logger,
                            ProtocolFactory protoFactory) {
    // ʵפ˼¹Ԥ³դƽ
    for (;;) {
      try{
        Socket clntSock = servSock.accept(); // ֥å³Ԥ
        Runnable protocol = protoFactory.createProtocol(clntSock, logger);
        protocol.run();
      } catch (IOException e) {
        logger.writeEntry("Exception = " + e.getMessage());
      }
    }
  }
}
