import java.net.*; // Socketɬ
import java.io.*;  // IOExceptionInput/OutputStreamɬ
import java.util.*; // ArrayListɬ

public class TimelimitEchoProtocolFactory implements ProtocolFactory {

  public Runnable createProtocol(Socket clntSock, Logger logger) {
    return new TimelimitEchoProtocol(clntSock, logger);
  }
}

class TimelimitEchoProtocol implements Runnable {
  private static final int BUFSIZE = 32; // ХåեΥХȥ
  private static final String TIMELIMIT = "10000"; // ǥեȤΥߥåȡʥߥá
  private static final String TIMELIMITPROP = "Timelimit"; // åɥץѥƥ

  private int timelimit;
  private Socket clntSock;
  private Logger logger;

  public TimelimitEchoProtocol(Socket clntSock, Logger logger) {
    this.clntSock = clntSock;
    this.logger = logger;
    // Systemץѥƥ饿ߥåȤ뤫ǥեͤѤ
    timelimit = Integer.parseInt(System.getProperty(TIMELIMITPROP, TIMELIMIT));
  }

  public void run() {
    ArrayList entry = new ArrayList();
    entry.add("Client address and port = " +
      clntSock.getInetAddress().getHostAddress() + ":" +
      clntSock.getPort());
    entry.add("Thread = " + Thread.currentThread().getName());

    try{
      // åȤϤӽI/Oȥ꡼
      InputStream in = clntSock.getInputStream();
      OutputStream out = clntSock.getOutputStream();

      int recvMsgSize; // åΥ
      int totalBytesEchoed = 0; // 饤ȤХȿ
      byte[] echoBuffer = new byte[BUFSIZE]; // Хåե
      long endTime = System.currentTimeMillis() + timelimit;
      int timeBoundMillis = timelimit;

      clntSock.setSoTimeout(timeBoundMillis);

      // 饤Ȥ³򥯥-1ɽ蘆ˤޤǼ
      while ((timeBoundMillis > 0) && // ͤª
            ((recvMsgSize = in.read(echoBuffer)) != -1)) {
        out.write(echoBuffer, 0, recvMsgSize);
        totalBytesEchoed += recvMsgSize;
        timeBoundMillis = (int) (endTime - System.currentTimeMillis());
        clntSock. setSoTimeout(timeBoundMillis);
      }

      entry.add("Client finished; echoed " + totalBytesEchoed + " bytes.");
    } catch (InterruptedIOException dummy) {
      entry.add("Read timed out");
    } catch (IOException e) {
      entry.add("Exception = " + e.getMessage());
    }

    try { // åȤ򥯥
      clntSock.close();
    } catch (IOException e) {
      entry.add("Exception = " + e.getMessage());
    }

    logger.writeEntry(entry);
  }
}
